"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.emit = emit;
exports.on = on;
exports.off = off;
exports.TYPE_UNHANDLED_REJECTION = exports.TYPE_UNHANDLED_ERROR = exports.TYPE_REFRESH = exports.TYPE_BUILD_ERROR = exports.TYPE_BUILD_OK = void 0;
var _extends = require("@swc/helpers/lib/_extends.js").default;
const TYPE_BUILD_OK = 'build-ok';
exports.TYPE_BUILD_OK = TYPE_BUILD_OK;
const TYPE_BUILD_ERROR = 'build-error';
exports.TYPE_BUILD_ERROR = TYPE_BUILD_ERROR;
const TYPE_REFRESH = 'fast-refresh';
exports.TYPE_REFRESH = TYPE_REFRESH;
const TYPE_UNHANDLED_ERROR = 'unhandled-error';
exports.TYPE_UNHANDLED_ERROR = TYPE_UNHANDLED_ERROR;
const TYPE_UNHANDLED_REJECTION = 'unhandled-rejection';
exports.TYPE_UNHANDLED_REJECTION = TYPE_UNHANDLED_REJECTION;
let handlers = new Set();
let queue = [];
function drain() {
    // Draining should never happen synchronously in case multiple handlers are
    // registered.
    setTimeout(function() {
        while(// Until we are out of events:
        Boolean(queue.length) && // Or, if all handlers removed themselves as a result of handling the
        // event(s)
        Boolean(handlers.size)){
            const ev = queue.shift();
            handlers.forEach((handler)=>handler(ev));
        }
    }, 1);
}
function emit(ev) {
    queue.push(Object.freeze(_extends({}, ev)));
    drain();
}
function on(fn) {
    if (handlers.has(fn)) {
        return false;
    }
    handlers.add(fn);
    drain();
    return true;
}
function off(fn) {
    if (handlers.has(fn)) {
        handlers.delete(fn);
        return true;
    }
    return false;
}

if ((typeof exports.default === 'function' || (typeof exports.default === 'object' && exports.default !== null)) && typeof exports.default.__esModule === 'undefined') {
  Object.defineProperty(exports.default, '__esModule', { value: true });
  Object.assign(exports.default, exports);
  module.exports = exports.default;
}

//# sourceMappingURL=bus.js.map