"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.ShadowPortal = void 0;
var _interop_require_wildcard = require("@swc/helpers/lib/_interop_require_wildcard.js").default;
var React = _interop_require_wildcard(require("react"));
var _reactDom = require("react-dom");
const ShadowPortal = function Portal({ children , globalOverlay ,  }) {
    let mountNode = React.useRef(null);
    let portalNode = React.useRef(null);
    let shadowNode = React.useRef(null);
    let [, forceUpdate] = React.useState();
    React.useLayoutEffect(()=>{
        const ownerDocument = globalOverlay ? document : mountNode.current.ownerDocument;
        portalNode.current = ownerDocument.createElement('nextjs-portal');
        shadowNode.current = portalNode.current.attachShadow({
            mode: 'open'
        });
        ownerDocument.body.appendChild(portalNode.current);
        forceUpdate({});
        return ()=>{
            if (portalNode.current && portalNode.current.ownerDocument) {
                portalNode.current.ownerDocument.body.removeChild(portalNode.current);
            }
        };
    }, [
        globalOverlay
    ]);
    return shadowNode.current ? /*#__PURE__*/ (0, _reactDom).createPortal(children, shadowNode.current) : globalOverlay ? null : /*#__PURE__*/ React.createElement("span", {
        ref: mountNode
    });
};
exports.ShadowPortal = ShadowPortal;

if ((typeof exports.default === 'function' || (typeof exports.default === 'object' && exports.default !== null)) && typeof exports.default.__esModule === 'undefined') {
  Object.defineProperty(exports.default, '__esModule', { value: true });
  Object.assign(exports.default, exports);
  module.exports = exports.default;
}

//# sourceMappingURL=ShadowPortal.js.map